/*=============================================================================
  Copyright (c) 1999-2003 pmG Worldwide, LLC.

  Author: Lyle Milton
  Date: 03/14/03

  Description: Simple effect that causes a point to lag behind the motion of the 
  object based on their distance from the pivot.
  See the tutorials section of the docs for a detailed description of this file.	

=============================================================================*/
#define _MAINPLUGIN_FILE
#include "LagPoints.h"

_pluginEntry
// FXint messiahEntry(FXchar pname[256], FXvoid *api_func, FXint api, FXint program, const FXchar *rev)
{
	// Get all API components and do initial plugin setup
	_MESSIAH_PLUGIN_ALL("LagPoints");

	// Describe the effect in English
	fxModuleDescription("Points lag behind the motion of the object based on their distance from the pivot", FX_NOFLAG);

	// Request AN messages
	fxModuleAccess(ACCESS_OBJECT, O_CREATE|O_DESTROY|O_LOAD|O_SAVE, FX_NOFLAG);
	fxModuleAccess(ACCESS_SYSTEM, S_MODULE_INIT, FX_NOFLAG);
	fxModuleAccess(ACCESS_INTERFACE, IN_CREATE, FX_NOFLAG);
	fxModuleAccess(ACCESS_PROCESS, P_POST_POINT_DISPLACE, FX_NOFLAG);

	// Register the effect
	fxModuleRegister( FX_MODTYPE_EFFECT, "LagPoints", &LagPointsAccess, FX_NOFLAG);

	return FX_PLUGIN_OK;
}

_pluginExit
// FXvoid messiahExit(FXvoid)
{

}
