/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: PLUGNAME.h

  Author: YOU
  Date: DATE

  Description: 

=============================================================================*/
#define _MESSIAH_FULL_API
#include <messiah_main.h>
#include <limits.h>

#ifdef __cplusplus

	#pragma warning ( disable : 4800 )	// coercion to bool warning ( boost causes this warning )
	#include <boost/lexical_cast.hpp>
	#include <string>
	#include <vector>
	#include <algorithm>	// sort, lower_bound, upper_bound, merge, min_element, max_element,

	// ********************************************************************************************************
	// DATA TYPES
	// ********************************************************************************************************
	struct userListType
	{
		struct	element_type
		{
			element_type() {} 
			element_type(const element_type& rhs):_val(rhs._val) {}
			element_type( std::string &rhs ) : _val(rhs) {}
			operator=( const element_type& rhs) { _val = rhs._val; }
			operator=( std::string &rhs ) { _val = rhs; }
			std::string & as_string() { return _val; }
			std::string	_val;
		};

		//typedef std::string						element_type;
		typedef std::vector< element_type >		element_list_type;
		typedef element_list_type::iterator		element_iterator;

		element_list_type	elements;
		bool				error;
		std::string			errStr;
	};

	typedef std::vector< userListType * >	masterListType;
	typedef masterListType::iterator		masterListIterator;

	// ********************************************************************************************************
	// <algorithm> FUNCTORS
	// ********************************************************************************************************
	class comp_userListElement
	{
	public:
		comp_userListElement( bool numeric = false ) : numericCompare( numeric ) {}

		inline bool	operator()( userListType::element_type	a, userListType::element_type b ) const;

		bool numericCompare;
	};


	// ********************************************************************************************************
	// INTERNAL HELPER FUNCTIONS
	// ********************************************************************************************************

	masterListType &	_getMaster		();
	userListType *		_getList		( int list );
	void				_killList		( int list );
	std::string &		_getElement		( int list, int index );

	template< typename T >
	bool				_setListElement	( FXint list, FXint index, T value );

#endif

// ********************************************************************************************************
// GENERAL LIST FUNCTIONS
// ********************************************************************************************************

/////////////////////////////////////////////////////////////
// getList_arg	(general purpose list index arg struct)
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint	list;
}getList_arg;
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// newList
/////////////////////////////////////////////////////////////

FX_EXPFUNC(newList_func, void, data);
FX_FUNC( FXint, newList_internal )( void );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// deleteList
/////////////////////////////////////////////////////////////

FX_EXPFUNC(deleteList_func, getList_arg, data);
FX_FUNC( FXint, deleteList_internal )( FXint list );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListSize
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListSize_func, getList_arg, data);
FX_FUNC( FXint, getListSize_internal )( FXint list );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListError
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListError_func, getList_arg, data);
FX_FUNC( FXint, getListError_internal )( FXint list );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListErrorString
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListErrorString_func, getList_arg, data);
FX_FUNC( FXchar *, getListErrorString_internal )( FXint list );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// clearListError
/////////////////////////////////////////////////////////////

FX_EXPFUNC(clearListError_func, getList_arg, data);
FX_FUNC( FXint, clearListError_internal )( FXint list );
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// sortList
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint	list;
	FXint	numeric;
}sortList_arg;

FX_EXPFUNC(sortList_func, sortList_arg, data);
FX_FUNC( FXint, sortList_internal )( FXint list, FXint numeric );
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// copyListToString
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint		list;
	FXchar *	delimeter;
}copyListToString_arg;

FX_EXPFUNC(copyListToString_func, copyListToString_arg, data);
FX_FUNC( FXchar *, copyListToString_internal )( FXint list, FXchar * delimeter );
/////////////////////////////////////////////////////////////

// ********************************************************************************************************
// LEXICAL CONVERSION FUNCTIONS
// ********************************************************************************************************

//		***		//
//		SET		//
//		***		//

/////////////////////////////////////////////////////////////
// setListInt
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint	list;
	FXint	index;
	FXint	value;	// used in "set" operation only!
}setListInt_arg;

FX_EXPFUNC(setListInt_func, setListInt_arg, data);
FX_FUNC( FXint, setListInt_internal )( FXint list, FXint index, FXint value );
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// setListDouble
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint		list;
	FXint		index;
	FXdouble	value;	// used in "set" operation only!
}setListDouble_arg;

FX_EXPFUNC(setListDouble_func, setListDouble_arg, data);
FX_FUNC( FXint, setListDouble_internal )( FXint list, FXint index, FXdouble value );
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// setListObject
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint		list;
	FXint		index;
	FXobject	value;	// used in "set" operation only!
}setListObject_arg;

FX_EXPFUNC(setListObject_func, setListObject_arg, data);
FX_FUNC( FXint, setListObject_internal )( FXint list, FXint index, FXobject value );
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// setListString
/////////////////////////////////////////////////////////////
typedef struct
{
	FXint		list;
	FXint		index;
	FXchar *	value;	// used in "set" operation only!
}setListString_arg;

FX_EXPFUNC(setListString_func, setListString_arg, data);
FX_FUNC( FXint, setListString_internal )( FXint list, FXint index, FXchar * value );
/////////////////////////////////////////////////////////////

//		***		//
//		GET		//
//		***		//

/////////////////////////////////////////////////////////////
// getListInt ( reuses setListInt_arg struct, DO NOT USE value ELEMENT!!! )
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListInt_func, setListInt_arg, data);
FX_FUNC( FXint, getListInt_internal )( FXint list, FXint index );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListDouble ( reuses setListDouble_arg struct, DO NOT USE value ELEMENT!!! )
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListDouble_func, setListDouble_arg, data);
FX_FUNC( FXdouble, getListDouble_internal )( FXint list, FXint index );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListObject ( reuses setListObject_arg struct, DO NOT USE value ELEMENT!!! )
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListObject_func, setListObject_arg, data);
FX_FUNC( FXobject, getListObject_internal )( FXint list, FXint index );
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// getListString ( reuses setListString_arg struct, DO NOT USE value ELEMENT!!! )
/////////////////////////////////////////////////////////////

FX_EXPFUNC(getListString_func, setListString_arg, data);
FX_FUNC( FXchar *, getListString_internal )( FXint list, FXint index );
/////////////////////////////////////////////////////////////



