/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_action.h
	Author:	Lyle Milton
	Date:	05/29/03

	------------------------------------------------------------



=============================================================================*/

#ifdef _MESSIAH_API_ACTION

#ifndef __MESSIAH_ACTION
#define __MESSIAH_ACTION


#ifndef __MESSIAH_HIDE_TYPES

	//action module types,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_ACTMODULE_ONETIME		0 //executes once based on a mouseclick, or other one time op
	#define FX_ACTMODULE_FULLTIME		1 //executes based on a mousedrag, or other interactive/realime op

	//alternate descriptive action module names
	#define FX_ACTMODULE_CLICK			FX_ACTMODULE_ONETIME
	#define FX_ACTMODULE_DRAG			FX_ACTMODULE_FULLTIME

	//action data class
	#define	FX_ACTCLASS_COMMAND			0
	#define	FX_ACTCLASS_SCRIPT			1
	#define	FX_ACTCLASS_MODULE			2

	//action type
	#define FX_ACTTYPE_DRAG				0
	#define FX_ACTTYPE_MOUSEDOWN		1 //
	#define FX_ACTTYPE_DOUBLECLICK		2
	#define FX_ACTTYPE_MOUSEIN			3
	#define FX_ACTTYPE_MOUSEOUT			4
	#define FX_ACTTYPE_MOUSEUP			5 //
	#define FX_ACTTYPE_LOSEFOCUS		6

	//EX:
	//		actionID = fxActionCreate(handleID, FX_ACTCLASS_COMMAND, FX_ACTTYPE_MOUSEDOWN, "View Quad On/Off", 0);

#endif //__MESSIAH_HIDE_TYPES



FX_API(FXint, fxInitAction)(FXint action_module);

FX_API(FXaction, fxActionCreate)(FXentity target, FXint action_class, FXint action_type, FXchar *action_name, FXint flags);

FX_API(FXvoid*, fxActionFormatData)(FXaction, FXint flags);

FX_API(FXint, fxActionType)(FXaction, FXint *a_type);

FX_API(FXint, fxActionTypeSet)(FXaction, FXint a_type);

FX_API(FXint, fxActionClass)(FXaction, FXint *a_class);

FX_API(FXaction, fxActionFirst)(FXentity target, FXint flags);

FX_API(FXaction, fxActionNext)(FXaction, FXint flags);

FX_API(FXaction, fxActionPrev)(FXaction, FXint flags);

FX_API(FXhandle, fxActionHandle)(FXaction, FXint flags);

FX_API(FXint, fxActionSetHandle)(FXaction, FXhandle, FXint flags);

FX_API(FXint, fxActionSetSibling)(FXaction actionID, FXaction sibID, FXint flags);

FX_API(FXint, fxActionMouse)(FXaction, FXint button, FXint *channel, FXint *coord_sys, FXint *mouse_flags, FXint *flags);

FX_API(FXint, fxActionMouseSet)(FXaction, FXint button, FXint channel, FXint coord_sys, FXint mouse_flags, FXint flags);

FX_API(FXint, fxActionMouseButton)(FXint flags);

FX_API(FXint, fxActionOptions)(FXaction, FXint *opt, FXint flags);

FX_API(FXint, fxActionOptionsSet)(FXaction, FXint opt, FXint flags);

FX_API(FXint, fxActionOptionsClear)(FXaction, FXint opt, FXint flags);



#define _MESSIAH_PTR_ACTION	messiah_apicomponent = FX_APIFUNCS_ACTION;\
								FX_PTR(fxInitAction);\
								FX_PTR(fxActionCreate);\
								FX_PTR(fxActionFormatData);\
								FX_PTR(fxActionType);\
								FX_PTR(fxActionTypeSet);\
								FX_PTR(fxActionClass);\
								FX_PTR(fxActionFirst);\
								FX_PTR(fxActionNext);\
								FX_PTR(fxActionPrev);\
								FX_PTR(fxActionHandle);\
								FX_PTR(fxActionSetHandle);\
								FX_PTR(fxActionSetSibling);\
								FX_PTR(fxActionMouse);\
								FX_PTR(fxActionMouseSet);\
								FX_PTR(fxActionMouseButton);\
								FX_PTR(fxActionOptions);\
								FX_PTR(fxActionOptionsSet);\
								FX_PTR(fxActionOptionsClear)


#endif //__MESSIAH_ACTION


#endif //_MESSIAH_API_ACTION


