#define FX_V3NORM(_a) fxNormalize(_a)  //normalize vector

FX_API(FXvoid, fxNormalize)(FXdouble vec[3]);
FX_API(FXvoid, fxGetViewOrigin)(FXdouble origin[3]);
FX_API(FXvoid, fxGetViewDirection)(FXdouble direction[3]);
FX_API(FXvoid, fxComputeNormal)(FXvecd vertex1, FXvecd vertex2, FXvecd vertex3, FXdouble normal[3]);
FX_API(FXint, fxBarycentricCoordinates)(FXvecd point, FXvecd vertex1, FXvecd vertex2, FXvecd vertex3, FXvecd normal, FXdouble barycentric[3]);
FX_API(FXvoid, fxBarycentricToWorld)(FXvecd barycentric, FXvecd vertex1, FXvecd vertex2, FXvecd vertex3, FXdouble worldpos[3]);
FX_API(FXdouble, fxPointOnPlane)(FXvecd point_to_plane, FXvecd planenormal, FXvecd planepoint, FXdouble point_on_plane[3]);
FX_API(FXint, fxRayIntersectPlane)(FXvecd rayStart, FXvecd rayDir, FXvecd plane_normal, FXvecd plane_point, FXdouble *t, FXdouble point_on_plane[3], FXint cull);
FX_API(FXint, fxRayIntersectTriangle)(FXvecd rayStart, FXvecd rayDir, FXvecd v1, FXvecd v2, FXvecd v3, FXdouble *t, FXdouble barycentric[3], FXint cull);
FX_API(FXint, fxRayIntersectTriangle2)(FXvecd rayStart, FXvecd rayDir, FXvecd v1, FXvecd v2, FXvecd v3, FXdouble *t, FXdouble barycentric[3], FXint cull);
FX_API(FXint, fxRayIntersectPolygon)(FXvecd rayStart, FXvecd rayDir, FXobject target, FXint polygon, FXdouble *t, FXint triangle[3], FXdouble barycentric[3], FXint cull);
FX_API(FXint, fxRayIntersectTarget)(FXvecd rayStart, FXvecd rayDir, FXobject target, FXdouble *t, FXint *polygon, FXint triangle[3], FXdouble barycentric[3], FXint cull);
FX_API(FXvoid, fxComputeBestFitNormal)(FXvecd *vertex, FXint vertexCount, FXdouble normal[3]);
FX_API(FXint *, fxGetNeighbourPoints)(FXobject target, FXint point, FXint *count);
FX_API(FXint, fxEffectTargetCount)(FXint effectid);
FX_API(FXdouble, fxPointOnTri)(FXvecd p, FXvecd v1, FXvecd v2, FXvecd v3, FXdouble pos[3], FXdouble bc[3]);

#define _USEFUL_GEN		fxNormalize = fxGetAPIFunc("useful_Normalize", FX_APIFUNCS_CUSTOM);\
						fxGetViewOrigin = fxGetAPIFunc("useful_GetViewOrigin", FX_APIFUNCS_CUSTOM);\
						fxGetViewDirection = fxGetAPIFunc("useful_GetViewDirection", FX_APIFUNCS_CUSTOM);\
						fxComputeNormal = fxGetAPIFunc("useful_ComputeNormal", FX_APIFUNCS_CUSTOM);\
						fxBarycentricCoordinates = fxGetAPIFunc("useful_BarycentricCoordinates", FX_APIFUNCS_CUSTOM);\
						fxBarycentricToWorld = fxGetAPIFunc("useful_BarycentricToWorld", FX_APIFUNCS_CUSTOM);\
						fxPointOnPlane = fxGetAPIFunc("useful_PointOnPlane", FX_APIFUNCS_CUSTOM);\
						fxRayIntersectPlane = fxGetAPIFunc("useful_RayIntersectPlane", FX_APIFUNCS_CUSTOM);\
						fxRayIntersectTriangle = fxGetAPIFunc("useful_RayIntersectTriangle", FX_APIFUNCS_CUSTOM);\
						fxRayIntersectTriangle2 = fxGetAPIFunc("useful_RayIntersectTriangle2", FX_APIFUNCS_CUSTOM);\
						fxRayIntersectPolygon = fxGetAPIFunc("useful_RayIntersectPolygon", FX_APIFUNCS_CUSTOM);\
						fxRayIntersectTarget = fxGetAPIFunc("useful_RayIntersectTarget", FX_APIFUNCS_CUSTOM);\
						fxComputeBestFitNormal = fxGetAPIFunc("useful_ComputeBestFitNormal", FX_APIFUNCS_CUSTOM);\
						fxGetNeighbourPoints = fxGetAPIFunc("useful_GetNeighbourPoints", FX_APIFUNCS_CUSTOM);\
						fxEffectTargetCount = fxGetAPIFunc("useful_EffectTargetCount", FX_APIFUNCS_CUSTOM);\
						fxPointOnTri = fxGetAPIFunc("useful_PointOnTri", FX_APIFUNCS_CUSTOM);
